package com.huimv.environment.controller;


import com.huimv.common.result.Result;
import com.huimv.environment.entity.DeviceUpDataEntity;
import com.huimv.environment.entity.WarningInfoEntity;
import com.huimv.environment.service.IEnvironmentControlService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;

import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@RestController
@RequestMapping(value = "/environmentControl")
public class EnvironmentControlController {
    @Autowired
    private IEnvironmentControlService envControlService;

    @RequestMapping(value = "/getFarm",method = RequestMethod.GET)
    public Result getPigpen(@RequestParam(value = "farmId") Integer farmId){
        return envControlService.getPigpenByFarm(farmId);
    }

    @RequestMapping(value = "/getLastEnvData",method = RequestMethod.GET)
    public Result getLastEnvData(@RequestParam(value = "lqId") Integer lqId){
        return envControlService.getLastEnvData(lqId);
    }

    @RequestMapping(value = "/getAllFarm")
    public Result getAllFarm(){
        return envControlService.getAllFarm();
    }


    @RequestMapping(value = "/getAllBylqid")
    public Result getAllBylaid(String lqid){
        return envControlService.getAllBylqid(lqid);
    }


    @RequestMapping(value = "/warningInfor")
    public Result warningInfor(){
        return envControlService.warningInfor();
    }

    @RequestMapping(value = "/findByZSID")
    public Result findByZSID(){
        return envControlService.findByZSID();
    }


    //定时检测数据库中是否有数据
    @Scheduled(cron = "0 0 5 * * ? ")
//    @RequestMapping(value = "/examine")
    public void examine(){
        envControlService.examine();
    }


    @RequestMapping(value = "/findExamine")
    public Result findExamine(){
       return envControlService.findExamine();
    }


    //查找当天最新的10条数据
    @RequestMapping(value = "/findAllByTime")
    public List<DeviceUpDataEntity> findAllByTime(){
        return envControlService.findAllByTime();
    }


    @Scheduled(cron = "0 1/15 * * * ? ")
    public void test(){
        RestTemplate restTemplate = new RestTemplate();
        DeviceUpDataEntity[] forObject = restTemplate.getForObject("http://127.0.0.1:8085/environmentControl/findAllByTime", DeviceUpDataEntity[].class);

        envControlService.save(forObject);

    }

}
