package com.huimv.environment.controller;

import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.huimv.environment.entity.IndexParameter2Entity;
import com.huimv.environment.entity.IndexParameterEntity;
import com.huimv.environment.entity.WarningInfoEntity;
import com.huimv.environment.entity.WarningParameter;
import com.huimv.environment.repo.WarningInfoEntityRepo;
import com.huimv.environment.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import sun.misc.IOUtils;

import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;

import java.util.*;

/**
 * <p>
 *
 * </p>
 *
 * @author yinhao
 * @date 2021/5/31 18:40
 */
@RestController
@RequestMapping("/productDataHandle")
public class ProductDataHandleController {

    @Autowired
    private WarningInfoEntityRepo warningInfoEntityRepo;


    @RequestMapping("/handleLocalWarningInfo")
    @Transactional(rollbackFor = Throwable.class)
    public Result handleLocalWarningInfo(@RequestBody HashMap<String,List<IndexParameter2Entity>> httpEntity) {
        System.out.println(httpEntity);

        List<IndexParameter2Entity> saveList = httpEntity.get("saveList");
        List<IndexParameter2Entity> updateList = httpEntity.get("updateList");

        Date date = new Date();

        if (CollectionUtil.isNotEmpty(saveList)) {
            for (IndexParameter2Entity entity : saveList) {
                WarningInfoEntity warningInfoEntity = new WarningInfoEntity();
                warningInfoEntity.setUploadTime(date);
                warningInfoEntity.setWarningType(3);
                String type = "本地数据的 " + entity.getName() + " 参数小于阈值!";
                warningInfoEntity.setShowStatus(0);
                warningInfoEntity.setType(type);
                warningInfoEntityRepo.updatePreviousShowStatusByType(type);
                warningInfoEntityRepo.save(warningInfoEntity);
            }
        }
        if (CollectionUtil.isNotEmpty(updateList)) {
            List<WarningInfoEntity> list = new ArrayList<>();
            for (IndexParameter2Entity entity : updateList) {
                List<WarningInfoEntity> warningInfoEntityList = warningInfoEntityRepo.findDataTypeLikeLeNow("本地数据的 " + entity.getName(), date);
                list.addAll(warningInfoEntityList);
            }
            if (CollectionUtil.isNotEmpty(list)) {
                for (WarningInfoEntity warningInfoEntity : list) {
                    warningInfoEntity.setShowStatus(1);
                    warningInfoEntityRepo.saveAndFlush(warningInfoEntity);
                }
            }
        }
        return new Result(1000,"请求成功");

    }

    @RequestMapping("/handleERPWarningInfo")
    @Transactional(rollbackFor = Throwable.class)
    public Result handleErpWarningInfo(@RequestBody HashMap<String,List<IndexParameterEntity>> httpEntity) {
        System.out.println(httpEntity);

        List<IndexParameterEntity> saveList = httpEntity.get("saveList");
        List<IndexParameterEntity> updateList = httpEntity.get("updateList");

        Date date = new Date();

        if (CollectionUtil.isNotEmpty(saveList)) {
            for (IndexParameterEntity entity : saveList) {
                WarningInfoEntity warningInfoEntity = new WarningInfoEntity();
                warningInfoEntity.setUploadTime(date);
                warningInfoEntity.setWarningType(3);
                warningInfoEntity.setShowStatus(0);
                String type = "ERP数据的 " + entity.getName() + " 参数小于阈值!";
                warningInfoEntity.setType(type);
                warningInfoEntityRepo.updatePreviousShowStatusByType(type);
                warningInfoEntityRepo.save(warningInfoEntity);
            }
        }
        if (CollectionUtil.isNotEmpty(updateList)) {
            List<WarningInfoEntity> list = new ArrayList<>();
            for (IndexParameterEntity entity : updateList) {
                List<WarningInfoEntity> warningInfoEntityList = warningInfoEntityRepo.findDataTypeLikeLeNow("ERP数据的 " + entity.getName(), date);
                list.addAll(warningInfoEntityList);
            }
            if (CollectionUtil.isNotEmpty(list)) {
                for (WarningInfoEntity warningInfoEntity : list) {
                    warningInfoEntity.setShowStatus(1);
                    warningInfoEntityRepo.saveAndFlush(warningInfoEntity);
                }
            }
        }

        return new Result(1000,"请求成功");

    }
}
