package com.huimv.environment.controller;

import com.huimv.common.result.Result;
import com.huimv.common.result.ResultCode;
import com.huimv.environment.entity.SetTemperatureEntity;
import com.huimv.environment.repo.SetTemperatureEntityRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.util.Date;
import java.util.List;
import java.util.Optional;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.environment.controller
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/5/28 0028 8:37
 **/
@RestController
@RequestMapping("/set")
public class SetTemperature {


    @Autowired
    private SetTemperatureEntityRepo setTemperatureEntityRepo;


    //之前写的温度设置表，但是有点浪费，在这里加上湿度控制表，为数据库第二条
    @RequestMapping(value = "/temperature", method = RequestMethod.POST)
    public Result setTemperature(HttpSession session,
                             @RequestParam(name = "high_temperature", required = true) String high_temperature,
                             @RequestParam(name = "low_temperature", required = true) String low_temperature,
                             @RequestParam(name = "remark", required = true) String remark,
                             HttpServletRequest req)  {
        Optional<SetTemperatureEntity> byId = setTemperatureEntityRepo.findById(1);
        byId.get().setHighTemperature(high_temperature);
        byId.get().setLowTemperature(low_temperature);
        byId.get().setRemark(remark);
        byId.get().setUpdataTime(new Date());
        byId.get().setCreateTimee(new Date());

        setTemperatureEntityRepo.save(byId.get());
        return  new Result(10000,"设置温度成功", true);
    }


    //设置湿度
    @RequestMapping(value = "/humidity", method = RequestMethod.POST)
    public Result setHumidity(HttpSession session,
                        @RequestParam(name = "high_humidity", required = true) String high_humidity,
                        @RequestParam(name = "low_humidity", required = true) String low_humidity,
                        @RequestParam(name = "remark", required = true) String remark,
                        HttpServletRequest req)  {
        Optional<SetTemperatureEntity> byId = setTemperatureEntityRepo.findById(2);
        byId.get().setHighTemperature(high_humidity);
        byId.get().setLowTemperature(low_humidity);
        byId.get().setRemark(remark);

        byId.get().setUpdataTime(new Date());
        byId.get().setCreateTimee(new Date());

        setTemperatureEntityRepo.save(byId.get());
        return  new Result(10000,"设置湿度成功", true);
    }



    @RequestMapping(value = "/findAll", method = RequestMethod.POST)
    public Result findAll()  {
        List<SetTemperatureEntity> all = setTemperatureEntityRepo.findAll();

        return  new Result(ResultCode.SUCCESS,all);
    }

}
