package com.huimv.environment.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Entity
@Table(name = "warning_info")
@Data
public class WarningInfoEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Integer id;

    /**
     * 温度
     */
    @Column(name = "temperature")
    private Double temperature;

    /**
     * 湿度
     */
    @Column(name = "humidity")
    private Integer humidity;

    /**
     * 上传时间
     */
    @Column(name = "upload_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GTM+8")
    private Date uploadTime;

    /**
     * 报警类型
     */
    @Column(name = "type")
    private String type;

    /**
     * 机器编号
     */
    @Column(name = "LQID")
    private String LQID;


    @Column(name = "warning_type")
    private Integer warningType;


    @Column(name = "show_status")
    private Integer showStatus;

}
