package com.farm.gateway;


import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.gateway.filter.ratelimit.KeyResolver;
import org.springframework.context.annotation.Bean;
import org.springframework.web.server.ServerWebExchange;
import reactor.core.publisher.Mono;

//@EnableDiscoveryClient
@SpringBootApplication
public class GatewayApplication {

    public static void main(String[] args) {
        SpringApplication.run(GatewayApplication.class, args);
    }

    /**
     * @Method      : tokenFilter
     * @Description : 启动全局过滤器，如果全局过滤器不加@Component注解，就必须要在这里加配置。
     * @Params      : []
     * @Return      : com.znsoft.gateway2.filter.TokenFilter
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/1/9       
     * @Time        : 11:11
     */
//    @Bean
//    public TokenFilter tokenFilter(){
//        return new TokenFilter();
//    }

    //注入bean
    @Bean
    public KeyResolver ipKeyResolver() {
        return exchange -> Mono.just(exchange.getRequest().getRemoteAddress().getHostName());
    }



}
