package com.huimv.production.controller;

import com.huimv.common.result.ResultCode;
import com.huimv.production.domain.IndexParameterEntity;
import com.huimv.production.result.Result;
import com.huimv.production.service.IndexParameterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.production.controller
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/5 0005 10:54
 **/
@RestController
@RequestMapping("/parameter")
public class IndexParameterController {
    @Autowired
    private IndexParameterService parameterService;

    @RequestMapping("/add")
    public Result add(IndexParameterEntity parameterEntity) {
        return parameterService.add(parameterEntity);
    }

    @RequestMapping("/remove")
    public Result add(Integer[] ids) {
        return parameterService.remove(ids);
    }

    @RequestMapping("/update")
    public Result update(IndexParameterEntity parameterEntity) {
        return parameterService.update(parameterEntity);
    }

    /* @RequestMapping("/findAll")
     public Result findAll(){
         return parameterService.findAll();
     }*/
    @RequestMapping("/findAll")
    public Result findAll() {
        // 获取数据源类型
        Result parameterResult = parameterService.getDatasourceType();
        String datasourceType = parameterResult.getData().toString();
        if(datasourceType.trim().equalsIgnoreCase("true")){
            // 从本地填报表获取数据
            return parameterService.findAllFrom2();
        }else{
            // 从远程落地表获取数据
            return parameterService.findAll();
        }
    }

    /**
     * @Method : setDatasourceType
     * @Description : 设置数据源类型
     * @Params : [datasourceType]
     * @Return : com.huimv.production.result.Result
     * @Author : ZhuoNing
     * @Date : 2021/5/22
     * @Time : 14:11
     */
    @RequestMapping(value = "/setDatasourceType", method = RequestMethod.POST)
    public Result setDatasourceType(@RequestParam(value = "datasourceType") String datasourceType) {
        return parameterService.setDatasourceType(datasourceType);
    }

    /**
     * @Method      : getDatasourceType
     * @Description : 读取数据源类型
     * @Params      : []
     * @Return      : com.huimv.production.result.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/22       
     * @Time        : 16:22
     */
    @RequestMapping(value = "/getDatasourceType", method = RequestMethod.GET)
    public Result getDatasourceType(){
        return parameterService.getDatasourceType();
    }


}
