package com.huimv.production.repo;

import com.huimv.production.domain.WarningInfoEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.Date;
import java.util.List;

public interface WarningInfoEntityRepo extends JpaRepository<WarningInfoEntity, Integer>, JpaSpecificationExecutor<WarningInfoEntity> {

    @Query(nativeQuery = true,value = "SELECT * FROM warning_info WHERE type like CONCAT('%',?1,'%') AND upload_time < ?2")
    List<WarningInfoEntity> findDataTypeLikeLeNow(String name, Date date);

    List<WarningInfoEntity> findAllByShowStatus(int showStatus);

    @Query(nativeQuery = true,value = "UPDATE warning_info SET show_status = 1 WHERE type = ?1 AND show_status = 0")
    void updatePreviousShowStatusByType(String type);
}