package com.huimv.production.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.huimv.production.domain.IndexAllEntity;
import com.huimv.production.repo.IndexAllEntityRepository;
import com.huimv.production.result.Result;
import com.huimv.production.result.ResultStatus;
import com.huimv.production.service.IndexAllService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.production.service.impl
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/5 0005 17:43
 **/
@Service
public class IndexAllServiceImpl  implements IndexAllService {

    @Autowired
    private IndexAllEntityRepository repository;

    @Override
    public Result add(IndexAllEntity allEntity) {

        String day = DateUtil.format(new Date(), "MM/dd");
        IndexAllEntity byDay = repository.findByDay(day);
        if (byDay != null){
            return new Result(10002,"每天只能添加一次");
        }
        allEntity.setDay(day);
        allEntity.setTotalQuantity(allEntity.getSow()+allEntity.getSow());
        repository.save(allEntity);
        return new Result(10000,"添加成功");
    }

    @Override
    public Result update(IndexAllEntity allEntity) {

        repository.save(allEntity);
        return new Result(10000,"修改成功");
    }
/*
    @Override
    public Result findAll() {
        repository.findAll();*/
@Override
public Result findAll(String name ,Integer pageNum , Integer pageSize) {
    try {
        Map map = new HashMap();
        int size = repository.findAll().size();
        Integer startPage = (pageNum - 1) * pageSize;
        List<IndexAllEntity> all = repository.findAll(name, startPage, pageSize);
        map.put("total", size);
        map.put("totalPageNum", (size + pageSize - 1) / pageSize);
        map.put("data", all);

        return new Result(10000, ResultStatus.findSuccess, map);
    } catch (Exception e) {
        return new Result(10001, ResultStatus.findFailed, null);
    }
}

}
