package com.huimv.production.service.impl;

import com.huimv.production.domain.IndexBoardEntity;
import com.huimv.production.domain.IndexParameterEntity;
import com.huimv.production.repo.IndexBoardEntityRepository;
import com.huimv.production.result.Result;
import com.huimv.production.result.ResultStatus;
import com.huimv.production.service.IndexBoardService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.production.service.impl
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/5 0005 10:55
 **/
@Service
public class IndexBoardServiceImpl implements IndexBoardService {
    @Autowired
    private IndexBoardEntityRepository boardEntityRepository;

    @Override
    public Result add(IndexBoardEntity boardEntity) {
        if (boardEntity == null){
            return new Result(10002,"请输入参数");
        }
        try {
            boardEntityRepository.save(boardEntity);
            return new Result(10000,"添加成功");
        }catch (Exception e){
            return new Result(10001,"添加失败");
        }
    }

    @Override
    public Result remove(Integer[] ids) {
        if (ids == null || ids.length==0){
            return new Result(10002,"请选择要删除的数据");
        }
        try {
            for (Integer id : ids) {
                boardEntityRepository.deleteById(id);
            }

            return new Result(10000,"删除成功");
        }catch (Exception e){
            return new Result(10001,"删除失败");
        }
    }

    @Override
    public Result update(IndexBoardEntity boardEntity) {
        if (boardEntity == null){
            return new Result(10002,"请选择要修改的值");
        }
        try {
            boardEntity.setCreateTime(boardEntityRepository.findById(boardEntity.getId()).get().getCreateTime());
            boardEntity.setUpdateTime(new Date());
            boardEntityRepository.save(boardEntity);
            return new Result(10000,"修改成功");
        }catch (Exception e){
            return new Result(10001,"修改失败");
        }
    }


    @Override
    public Result findAll(String name ,Integer pageNum , Integer pageSize) {
        try {
            Map map = new HashMap();
            int size = boardEntityRepository.findAll().size() ;
            Integer startPage = (pageNum-1) * pageSize;
            List<IndexBoardEntity> all = boardEntityRepository.findAll(name,startPage,pageSize);
            map.put("total",size);
            map.put("totalPageNum",(size  +  pageSize  - 1) / pageSize);
            map.put("data",all);

            return new Result(10000, ResultStatus.findSuccess,map);
        }catch (Exception e){
            return new Result(10001,ResultStatus.findFailed,null);
        }
    }




   /* @Override
    public Result findAll() {
        try {
            List<IndexBoardEntity> all = boardEntityRepository.findAll();
            return new Result(10000,"查询成功",all);
        }catch (Exception e){
            return new Result(10001,"查询失败",null);
        }
    }*/
}
