package com.huimv.production.service.impl;

import com.huimv.production.domain.ConfigEntity;
import com.huimv.production.domain.IndexParameterEntity;
import com.huimv.production.repo.ConfigEntityRepository;
import com.huimv.production.repo.IndexParameter2Repository;
import com.huimv.production.repo.IndexParameterEntityRepository;
import com.huimv.production.result.Result;
import com.huimv.production.result.ResultStatus;
import com.huimv.production.service.IndexParameterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.production.service.impl
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/5 0005 10:56
 **/
@Service
public class IndexParameterServiceImpl implements IndexParameterService {
    @Autowired
    private IndexParameterEntityRepository parameterEntityRepository;
    @Autowired
    private IndexParameter2Repository parameterEntityRepository2;
    @Autowired
    private ConfigEntityRepository configRepo;

    @Override
    public Result add(IndexParameterEntity parameterEntity) {
        if (parameterEntity == null){
           return new Result(10002,"请输入参数");
        }
        try {
            parameterEntity.setCheckParameter(false);
            parameterEntityRepository.save(parameterEntity);
            return new Result(10000,"添加成功");
        }catch (Exception e){
            return new Result(10001,"添加失败");
        }


    }

    @Override
    public Result remove(Integer[] ids) {
        if (ids == null || ids.length==0){
            return new Result(10002,"请选择要删除的数据");
        }
        try {
            for (Integer id : ids) {
                parameterEntityRepository.deleteById(id);
            }

            return new Result(10000,"删除成功");
        }catch (Exception e){
            return new Result(10001,"删除失败");
        }
    }
    //暂时有疑问
    @Override
    public Result update(IndexParameterEntity parameterEntity) {
        if (parameterEntity == null){
            return new Result(10002,"请选择要修改的值");
        }
        try {
            parameterEntity.setCreateTime(parameterEntityRepository.findById(parameterEntity.getId()).get().getCreateTime());
            parameterEntity.setUpdateTime(new Date());
            parameterEntityRepository.save(parameterEntity);
            return new Result(10000,"修改成功");
        }catch (Exception e){
            return new Result(10001,"修改失败");
        }
    }

    /**
     * @Method      : findAll
     * @Description : 
     * @Params      : []
     * @Return      : com.huimv.production.result.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/22       
     * @Time        : 16:58
     */
    @Override
    public Result findAll() {
        try {
            return new Result(10000, ResultStatus.findSuccess,parameterEntityRepository.findAll());
        }catch (Exception e){
            return new Result(10001, ResultStatus.findFailed,null);
        }
    }

    /**
     * @Method      : findAllFrom2
     * @Description : 
     * @Params      : []
     * @Return      : com.huimv.production.result.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/22       
     * @Time        : 17:32
     */
    @Override
    public Result findAllFrom2() {
        try {
            return new Result(10000, ResultStatus.findSuccess,parameterEntityRepository2.findAll());
        }catch (Exception e){
            return new Result(10001, ResultStatus.findFailed,null);
        }
    }
    
    /**
     * @Method      : setDatasourceType
     * @Description : 
     * @Params      : [datasourceType]
     * @Return      : com.huimv.production.result.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/5/22       
     * @Time        : 16:04
     */
    @Override
    public Result setDatasourceType(String datasourceType){
        // 先查询记录是否存在，存在就修改，不存在就添加
        ConfigEntity configEntity = new ConfigEntity();
        configEntity.setKey("datasourceType");;
        Example<ConfigEntity> example = Example.of(configEntity);
        Optional<ConfigEntity> configOptional = configRepo.findOne(example);
        if(configOptional.isPresent()){
            ConfigEntity configData = configOptional.get();
            configData.setValue(datasourceType);
            configRepo.saveAndFlush(configData);
        }else{
            ConfigEntity addConfigData = new ConfigEntity();
            addConfigData.setKey("datasourceType");
            addConfigData.setValue(datasourceType);
            configRepo.saveAndFlush(addConfigData);
        }
        return new Result(10000,"设置成功");
    }

    @Override
    public Result getDatasourceType() {
        String datasourceTypeVal = "true";
        ConfigEntity configEntity = new ConfigEntity();
        configEntity.setKey("datasourceType");;
        Example<ConfigEntity> example = Example.of(configEntity);
        Optional<ConfigEntity> configOptional = configRepo.findOne(example);
        if(configOptional.isPresent()){
            ConfigEntity configData = configOptional.get();
            datasourceTypeVal = configData.getValue();
        }else{
            ConfigEntity addConfigData = new ConfigEntity();
            addConfigData.setKey("datasourceType");
            addConfigData.setValue(datasourceTypeVal);
            configRepo.saveAndFlush(addConfigData);
        }
        return new Result(10000,"设置成功",datasourceTypeVal);
    }

  /*  @Override
    public Result findAll() {
        try {
            List<IndexParameterEntity> all = parameterEntityRepository.findAll();
            return new Result(10000,"查询成功",all);
        }catch (Exception e){
            return new Result(10001,"查询失败",null);
        }

    }*/
}
