package com.huimv.production.service.impl;

import com.huimv.production.domain.IndexProductionGroup2;
import com.huimv.production.domain.IndexProductionGroupEntity;
import com.huimv.production.repo.IndexProductionGroup2Repository;
import com.huimv.production.repo.IndexProductionGroupEntityRepository;
import com.huimv.production.result.Result;
import com.huimv.production.result.ResultStatus;
import com.huimv.production.service.IndexProductionGroup2Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class IndexProductionGroup2ServiceImpl implements IndexProductionGroup2Service {

	@Autowired
	private IndexProductionGroup2Repository rep;

	@Autowired
	private IndexProductionGroupEntityRepository indexProductionGroupRepo;

	@Override
	public Result add(IndexProductionGroup2 entity){
		if (entity == null){
			return new Result(10002, ResultStatus.addNull);
		}
		try {
			rep.save(entity);
			return new Result(10000,ResultStatus.addSuccess);
		}catch (Exception e){
			return new Result(10001,ResultStatus.addFailed);
		}
	}

	@Override
	public Result remove(Integer[] ids) {
		if (ids == null || ids.length==0){
			return new Result(10002,ResultStatus.deleteNull);
		}
		try {
			for (Integer id : ids) {
				rep.deleteById(id);
			}
			return new Result(10000,ResultStatus.deleteSuccess);
		}catch (Exception e){
			return new Result(10001,ResultStatus.deleteFailed);
		}
	}

	@Override
	public Result update(IndexProductionGroup2 entity) {
		if (entity == null){
			return new Result(10002,ResultStatus.updateNull);
		}
		try {
			rep.save(entity);
			return new Result(10000,ResultStatus.updateSuccess);
		}catch (Exception e){
			return new Result(10001,ResultStatus.updateFailed);
		}
	}

	@Override
	public Result findAll() {
		return new Result(10000,ResultStatus.findSuccess,rep.findAll());
	}

	@Override
	public Result findAllById(Integer id) {
		try {
			IndexProductionGroup2 entity = rep.findById(id).get();
			return new Result(10000,ResultStatus.findSuccess,entity);
		}catch (Exception e){
			return new Result(10001,ResultStatus.findFailed,null);
		}
	}

	@Override
	public Result findAllFrom() {
		List<IndexProductionGroupEntity> delivery = indexProductionGroupRepo.findAllByVariety("巴嘉");
		List<IndexProductionGroupEntity> reservice = indexProductionGroupRepo.findAllByVariety("杜巴嘉");
		List<IndexProductionGroupEntity> breeding = indexProductionGroupRepo.findAllByVariety("金华两头乌");
		Map map1 = new HashMap();
		Map map2 = new HashMap();
		Map map3 = new HashMap();
		map1.put("veriety","巴嘉");
		map2.put("veriety","杜巴嘉");
		map3.put("veriety","金华两头乌");
		for (IndexProductionGroupEntity productionGroup : delivery) {
			map1.put(productionGroup.getProductionType(),productionGroup.getFrequency());
		}
		for (IndexProductionGroupEntity productionGroup : reservice) {
			map2.put(productionGroup.getProductionType(),productionGroup.getFrequency());
		}
		for (IndexProductionGroupEntity productionGroup : breeding) {
			map3.put(productionGroup.getProductionType(),productionGroup.getFrequency());
		}

		List list = new ArrayList();
		list.add(map1);
		list.add(map2);
		list.add(map3);

		return new Result(10000,ResultStatus.findSuccess,list);
	}
}
