package com.huimv.production.service.impl;

import com.huimv.production.domain.IndexVariety;
import com.huimv.production.repo.IndexVariety2Repository;
import com.huimv.production.repo.IndexVarietyRepository;
import com.huimv.production.result.Result;
import com.huimv.production.result.ResultStatus;
import com.huimv.production.service.IndexVarietyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class IndexVarietyServiceImpl implements IndexVarietyService {

	@Autowired
	private IndexVarietyRepository rep;
	@Autowired
	private IndexVariety2Repository rep2;

	@Override
	public Result add(IndexVariety entity){
		if (entity == null){
			return new Result(10002, ResultStatus.addNull);
		}
		try {
			rep.save(entity);
			return new Result(10000,ResultStatus.addSuccess);
		}catch (Exception e){
			return new Result(10001,ResultStatus.addFailed);
		}
	}

	@Override
	public Result remove(Integer[] ids) {
		if (ids == null || ids.length==0){
			return new Result(10002,ResultStatus.deleteNull);
		}
		try {
			for (Integer id : ids) {
				rep.deleteById(id);
			}
			return new Result(10000,ResultStatus.deleteSuccess);
		}catch (Exception e){
			return new Result(10001,ResultStatus.deleteFailed);
		}
	}

	@Override
	public Result update(IndexVariety entity) {
		if (entity == null){
			return new Result(10002,ResultStatus.updateNull);
		}
		try {
			rep.save(entity);
			return new Result(10000,ResultStatus.updateSuccess);
		}catch (Exception e){
			return new Result(10001,ResultStatus.updateFailed);
		}
	}

	@Override
	public Result findAll() {
		return new Result(10000,ResultStatus.findSuccess,rep.findAll());
	}

	@Override
	public Result findAllById(Integer id) {
		try {
			IndexVariety entity = rep.findById(id).get();
			return new Result(10000,ResultStatus.findSuccess,entity);
		}catch (Exception e){
			return new Result(10001,ResultStatus.findFailed,null);
		}
	}

	@Override
	public Result findAllFrom2() {
		return new Result(10000,ResultStatus.findSuccess,rep2.findAll());
	}
}
