package com.huimv.production.service.impl;

import com.alibaba.druid.util.StringUtils;
import com.huimv.production.domain.BaoyvCount;
import com.huimv.production.domain.MSowCopulationEntity;
import com.huimv.production.domain.MSowFeed;
import com.huimv.production.repo.MSowCopulationEntityRepo;
import com.huimv.production.result.Result;
import com.huimv.production.service.MSowCopulationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;

import javax.persistence.criteria.Predicate;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.production.service.impl
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/9 0009 17:43
 **/
@Service
public class MSowCopulationServiceImpl implements MSowCopulationService {
    @Autowired
    private MSowCopulationEntityRepo childcareEntityRepo;

    @Override
    public Result add(MSowCopulationEntity childcareEntity) {
        if (childcareEntity == null){
            return new Result(10002,"请输入参数");
        }
//        try {
            childcareEntityRepo.save(childcareEntity);
            return new Result(10000,"添加成功");
//        }catch (Exception e){
//            return new Result(10001,"添加失败");
//        }
    }

    @Override
    public Result remove(Integer[] ids) {
        if (ids == null || ids.length==0){
            return new Result(10002,"请选择要删除的数据");
        }
        try {
            for (Integer id : ids) {
                childcareEntityRepo.deleteById(id);
            }

            return new Result(10000,"删除成功");
        }catch (Exception e){
            return new Result(10001,"删除失败");
        }
    }

    @Override
    public Result update(MSowCopulationEntity childcareEntity) {
        if (childcareEntity == null){
            return new Result(10002,"请选择要修改的值");
        }
        try {
            childcareEntityRepo.save(childcareEntity);
            return new Result(10000,"修改成功");
        }catch (Exception e){
            return new Result(10001,"修改失败");
        }
    }

    @Override
    public Result findAll(String name ,Integer pageNum , Integer pageSize) {
        try {
            Map map = new HashMap();
            int size = childcareEntityRepo.findAll().size() ;
            Integer startPage = (pageNum-1) * pageSize;
            List<MSowCopulationEntity> all = childcareEntityRepo.findAll(name,startPage,pageSize);
            map.put("total",size);
            map.put("totalPageNum",(size  +  pageSize  - 1) / pageSize);
            map.put("data",all);
            return new Result(10000,"查询成功",map);
        }catch (Exception e){
            return new Result(10001,"查询失败",null);
        }
    }
    
}
