package com.huimv.production.service.impl;

import com.huimv.common.result.Result;
import com.huimv.common.result.ResultCode;
import com.huimv.production.domain.FarmSmEntity;
import com.huimv.production.domain.WarningInfoEntity;
import com.huimv.production.repo.FarmSmEntityRepo;
import com.huimv.production.repo.WarningInfoEntityRepo;
import com.huimv.production.service.WarningInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.production.service.impl
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/5/26 0026 14:03
 **/
@Service
public class WarningInfoServiceImpl implements WarningInfoService {

    @Autowired
    private WarningInfoEntityRepo warningInfoEntityRepo;

    @Autowired
    private FarmSmEntityRepo farmSmEntityRepo;

    @Override
    public Result warningInfor() {
        List<WarningInfoEntity> all = warningInfoEntityRepo.findAllByShowStatus(0);
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        List list  = new ArrayList();

        for (WarningInfoEntity warningInfoEntity : all) {
            Map map = new HashMap();
            Date uploadTime = warningInfoEntity.getUploadTime();
            String lqid = warningInfoEntity.getLQID();
            if (lqid == null || lqid == ""){
                map.put("farmName","");
                map.put("time",simpleDateFormat.format(uploadTime));
                map.put("msg",warningInfoEntity.getType());
                map.put("type",warningInfoEntity.getWarningType());
                list.add(map);
            }else {
                FarmSmEntity byLqid = farmSmEntityRepo.findByLQID(lqid);

                String name = byLqid.getName();
                String type = warningInfoEntity.getType();
                String str = type;

                map.put("farmName",name);
                map.put("time",simpleDateFormat.format(uploadTime));
                map.put("msg",str);
                map.put("type",warningInfoEntity.getWarningType());
                list.add(map);
            }



        }
        return new Result(ResultCode.SUCCESS,list);
    }
}
