package com.huimv.security.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Entity
@Table(name = "face_user")
@Data
public class FaceUserEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "ID", nullable = false)
    private Integer ID;

    /**
     * 牧场ID
     */
    @Column(name = "MCID")
    private Integer MCID;

    /**
     * 员工ID
     */
    @Column(name = "YGID")
    private Integer YGID;

    /**
     * user id
     */
    @Column(name = "USERID")
    private String USERID;

    /**
     * 姓名
     */
    @Column(name = "XM")
    private String XM;

    /**
     * 职位
     */
    @Column(name = "ZW")
    private String ZW;

    /**
     * 备注
     */
    @Column(name = "BZ")
    private String BZ;

    /**
     * 修改时间
     */
    @Column(name = "XGSJ")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
    @LastModifiedDate
    private Date XGSJ;

    /**
     * 作废标志
     */
    @Column(name = "ZFBZ")
    private Integer ZFBZ;

    @Column(name = "sbid")
    private String sbid;

    @Column(name = "sbmc")
    private String sbmc;

}
