package com.huimv.security.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.date.Month;
import cn.hutool.json.JSONObject;
import com.huimv.security.repo.FaceRecoEntityRepository;
import com.huimv.security.result.Result;
import com.huimv.security.service.FaceRecoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.security.service.impl
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/7 0007 15:44
 **/
@Service
public class FaceRecoServiceImpl implements FaceRecoService {
    @Autowired
    FaceRecoEntityRepository faceRecoEntityRepository;

    @Override
    public List intoOutCount() {
        return faceRecoEntityRepository.findAllByOOrderBySBID();
    }

    @Override
    public List oneDay() {
        DateTime date = DateUtil.date();
        int nowHour = Integer.parseInt((DateUtil.beginOfHour(date)+"").substring(11,13));
        DateTime beginOfDay = DateUtil.beginOfDay(new Date());

        List list = new ArrayList();
        for (int i=0;i<nowHour+1;i++){
            List allByXGSJBetween = faceRecoEntityRepository.findAllByXGSJBetween(DateUtil.offsetHour(beginOfDay, i), DateUtil.offsetHour(beginOfDay, i + 1));
            Map map = new HashMap();
            map.put((i+1)+":00",allByXGSJBetween.size());
            list.add(map);
        }

        return list;
    }

    @Override
    public List oneWeek() {
        DateTime endOfDay = DateUtil.endOfDay(new Date());
        List list = new ArrayList();
       for (int i = 0; i<7;i++){
           DateTime dateTime = DateUtil.offsetDay(endOfDay, -i);
           List allByXGSJBetween = faceRecoEntityRepository.findAllByXGSJBetween( DateUtil.offsetDay(endOfDay, -i - 1),dateTime);
           Map map = new HashMap();
           map.put((dateTime+"").substring(5,10),allByXGSJBetween.size());
           list.add(map);
       }

        return list;
    }

    @Override
    public List oneMouth() {

        DateTime endOfDay = DateUtil.endOfDay(new Date());
        List list = new ArrayList();
        int nowDay = Integer.parseInt((endOfDay+"").substring(8,10));

        for (int i = 0; i<nowDay;i++){
            DateTime dateTime = DateUtil.offsetDay(endOfDay, -i);
            List allByXGSJBetween = faceRecoEntityRepository.findAllByXGSJBetween( DateUtil.offsetDay(endOfDay, -i - 1),dateTime);
            Map map = new HashMap();
           map.put((dateTime+"").substring(5,10),allByXGSJBetween.size());
           list.add(map);
        }

        return list;
    }
}
