package com.huimv.video.controller;


import com.huimv.video.domain.MobileUser;
import com.huimv.video.result.Result;
import com.huimv.video.service.CameraInfoService;
import com.huimv.video.service.MobileUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController

@RequestMapping("/mobileUser")
public class MobileUserController {

	@Autowired
	private MobileUserService service;

	@Autowired
	private CameraInfoService cameraInfoService;

	@RequestMapping("/register")
	public Result add(MobileUser childcareEntity){ return service.add(childcareEntity); }

	@RequestMapping("/remove")
	public Result add(Integer[] ids){ return service.remove(ids); }

	@RequestMapping("/update")
	public Result update(MobileUser childcareEntity){
		return service.update(childcareEntity);
	}

	@RequestMapping("/findAll")
	public Result findAll(){ return service.findAll(); }

	@RequestMapping("/findAllById")
	public Result findAllById(Integer id){ return service.findAllById(id); }

	@RequestMapping("/updateIndex")
	public Result updateIndex(Integer id,Integer userId){ return service.updateIndex(id,userId); }

	@RequestMapping("/findIndex")
	public Result findIndex(Integer userId){
		List<Integer> list = new ArrayList();
		list.add(service.findIndex(userId));
		List cameraDetails = cameraInfoService.getCameraDetails(list);
		return new Result(10000,"查询成功",cameraDetails);
	}

	@RequestMapping("/login")
	public Result login(String account, String password){ return service.login(account,password); }

	@RequestMapping("/updatePassword")
	public Result updatePassword(Integer userId,String oldPwd,String newPwd){
		return service.updatePassword(userId,oldPwd,newPwd);
	}

	@RequestMapping("/findByAccount")
	public Result findByAccount(String account){
		return service.findByAccount(account);
	}

	@RequestMapping("/verifyUpdatePassword")
	public Result verifyUpdatePassword(Integer userId,String pwd){
		return service.verifyUpdatePassword(userId,pwd);
	}



}
