package com.huimv.video.service.impl;

import com.huimv.video.domain.CameraInfo;
import com.huimv.video.domain.MobileAttention;
import com.huimv.video.domain.PastureArea;
import com.huimv.video.repo.CameraInfoRepo;
import com.huimv.video.repo.MobileAttentionRepository;
import com.huimv.video.repo.PastureAreaRepo;
import com.huimv.video.result.Result;
import com.huimv.video.service.PastureAreaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.video.service.impl
 * @Description : TODO
 * @Author : yuxuexuan
 * @Create : 2021/3/4 0007 10:32
 **/
@Service
public class PastureAreaServiceImpl implements PastureAreaService {
    @Autowired
    private PastureAreaRepo pastureAreaRepo;

    @Autowired
    private CameraInfoRepo cameraInfoRepo;

    @Autowired
    private MobileAttentionRepository attentionRepository;

    @Override
    public void save(PastureArea pastureArea) {
        pastureAreaRepo.save(pastureArea);
    }

    @Override
    public void update(PastureArea pastureArea) {
        pastureAreaRepo.save(pastureArea);
    }

    @Override
    public void delete(List<Integer> ids) {
        for (Integer id : ids) {
            List<PastureArea> list = pastureAreaRepo.findAllByParentId(id);
            if (list != null && list.size()>0){
                for (PastureArea pastureArea : list) {
                    cameraInfoRepo.deleteByAreaId(pastureArea.getId());
                    pastureAreaRepo.deleteById(pastureArea.getId());
                }
            }
            pastureAreaRepo.deleteById(id);
        }
    }

    @Override
    public List findAll(Integer userId) {
        List list  = new ArrayList();
        Sort sort = Sort.by(Sort.Direction.ASC, "sort");
        List<MobileAttention> allByUserId = attentionRepository.findAllByUserId(userId);
        List<PastureArea> allArea = pastureAreaRepo.findAll(sort);
        for (MobileAttention mobileAttention : allByUserId) {
            for (PastureArea pastureArea : allArea) {
                if (pastureArea.getId() == mobileAttention.getAreaId()){
                    pastureArea.setAttention(1);
                }
            }
        }

        list = areaUtil(allArea);
        return list;
    }


    public List areaUtil(List<PastureArea> areaList){
        List<Map> list = new ArrayList<>();
        for (PastureArea pastureArea : areaList) {
            if(pastureArea.getParentId() == null){
                return null;
            }
            if (pastureArea.getParentId()==0){
                Map map  = new HashMap();
                map.put("id", pastureArea.getId());
                map.put("name", pastureArea.getName());
                map.put("parentId", pastureArea.getParentId());
                map.put("remark", pastureArea.getRemark());
                map.put("sort",pastureArea.getSort());

                List list1 = new ArrayList();
                for (PastureArea area : areaList) {
                    if (pastureArea.getId()==area.getParentId()){
                        list1.add(area);
                    }
                }
                map.put("children",list1);

                list.add(map);
            }
        }



        return list;
    }


    private boolean areaEntityIsChildren(PastureArea pastureArea, List<PastureArea> areaEntityList) {
        for (PastureArea pastureAreas : areaEntityList) {
            if (pastureArea.getId()==(pastureAreas.getParentId()) ){
                return true;
            }
        }
        return false;
    }


    @Override
    public List findAllByAttention() {
        return  pastureAreaRepo.findAllByAttention(1);
    }

    @Override
    public void updateAttention(Integer id,Integer attention) {
        PastureArea pastureArea = pastureAreaRepo.findById(id).get();
        pastureArea.setAttention(attention);
        pastureAreaRepo.save(pastureArea);

    }

    @Override
    public PastureArea findById(Integer id) {

        return  pastureAreaRepo.findAllById(id);
    }
}
